#!/usr/bin/env groovy
def gv
pipeline{
    agent any
    tools {
        maven 'Maven'
    }
    stages{
        stage('init app'){
            steps{
                script{
                    echo 'Start init...'
                    gv = load "script.groovy"
                    echo "Starting app on branch ${BRANCH_NAME}"
                }
            }
        }
        stage("increment version"){
            steps{
                script{
                    echo 'incrementing version'
                    sh 'mvn build-helper:parse-version versions:set -DnewVersion=\\\${parsedVersion.majorVersion}.\\\${parsedVersion.minorVersion}.\\\${parsedVersion.nextIncrementalVersion} versions:commit'
                    def matcher = readFile('pom.xml') =~ '<version>(.+)</version>'
                    def version = matcher[0][1]
                    env.IMAGE_NAME = "$version-$BUILD_NUMBER"
                    //env.IMAGE_NAME = 1.1.1
                }
            }
        }
        stage("build jar") {
            steps {
                script {
                    //echo "building jar"
                    gv.buildJar()
                }
            }
        }
        stage("build image and push image") {
            steps {
                script {
                    //gv.buildImage()
                    echo "building the docker image..."
                    withCredentials([usernamePassword(credentialsId: 'docker-hub-repo', passwordVariable: 'PASS', usernameVariable: 'USER')]) {
                        sh "docker build -t hossam1radwan/demo-app:${IMAGE_NAME} ."
                        sh "echo $PASS | docker login -u $USER --password-stdin"
                        sh "docker push hossam1radwan/demo-app:${IMAGE_NAME}"
                    }
                }
            }
        }
        stage("deploy") {
            environment {
                AWS_ACCESS_KEY_ID = credentials('jenkins_aws_access_key_id')
                AWS_SECRET_ACCESS_KEY = credentials('jenkins-aws_secret_access_key')
                APP_NAME = "java-maven-app"
            }
            steps {
                script {
                    //gv.deployApp()
                    echo 'deploying docker image...'
                    sh "envsubst < kubernetes/deployment.yaml | kubectl apply -f -"
                    sh "envsubst < kubernetes/service.yaml | kubectl apply -f -"
                }
            }
        }
        stage("commit version update"){
            steps{
                script{
                   withCredentials([usernamePassword(credentialsId: 'gitlab-credentials', passwordVariable: 'PASS', usernameVariable: 'USER')]) {
                        // git config here for the first time run
                        // sh 'git config --global user.email "jenkins@example.com"'
                        // sh 'git config --global user.name "jenkins"'

                        sh 'git status'
                        sh 'git branch'
                        sh 'git config --list'

                        sh "git remote set-url origin https://${USER}:${PASS}@gitlab.com/hossam.radwan.engineer/java-maven-app.git"
                        sh 'git add .'
                        sh 'git commit -m "ci: version bump"'
                        sh "git push origin HEAD:master"
                    }
 
                }
            }
        }
    }   
}
